Loading...
Searching...
No Matches
globjects::DebugMessage Class Reference

`#include <globjects/include/globjects/DebugMessage.h>`

## Public Types

enum class | Implementation { DebugKHR , Legacy }
using | Callback = std::function< void(const DebugMessage &)>

## Public Member Functions

| DebugMessage (gl::GLenum source, gl::GLenum type, gl::GLuint id, gl::GLenum severity, const std::string &message)
gl::GLenum | source () const
gl::GLenum | type () const
gl::GLuint | id () const
gl::GLenum | severity () const
const std::string & | message () const
virtual std::string | toString () const

## Static Public Member Functions

static void | hintImplementation (Implementation impl)
static void | enable (bool synchronous=true)
static void | disable ()
static void | setCallback (Callback callback)
static void | setSynchronous (bool synchronous)
static void | insertMessage (gl::GLenum source, gl::GLenum type, gl::GLuint id, gl::GLenum severity, gl::GLsizei length, const char *message)
static void | insertMessage (gl::GLenum source, gl::GLenum type, gl::GLuint id, gl::GLenum severity, const std::string &message)
static void | insertMessage (const DebugMessage &message)
static void | enableMessage (gl::GLenum source, gl::GLenum type, gl::GLenum severity, gl::GLuint id)
static void | enableMessages (gl::GLenum source, gl::GLenum type, gl::GLenum severity, gl::GLsizei count, const gl::GLuint *ids)
static void | enableMessages (gl::GLenum source, gl::GLenum type, gl::GLenum severity, const std::vector< gl::GLuint > &ids)
static void | disableMessage (gl::GLenum source, gl::GLenum type, gl::GLenum severity, gl::GLuint id)
static void | disableMessages (gl::GLenum source, gl::GLenum type, gl::GLenum severity, gl::GLsizei count, const gl::GLuint *ids)
static void | disableMessages (gl::GLenum source, gl::GLenum type, gl::GLenum severity, const std::vector< gl::GLuint > &ids)
static void | controlMessages (gl::GLenum source, gl::GLenum type, gl::GLenum severity, gl::GLsizei count, const gl::GLuint *ids, gl::GLboolean enabled)
static bool | isFallbackImplementation ()

## Protected Member Functions

std::string | severityString () const
std::string | sourceString () const
std::string | typeString () const

## Protected Attributes

gl::GLenum | m_source
gl::GLenum | m_type
gl::GLuint | m_id
gl::GLenum | m_severity
std::string | m_message

## Member Typedef Documentation

## Callback

using globjects::DebugMessage::Callback = std::function<void(const DebugMessage &)>

## Member Enumeration Documentation

## Implementation

enum class globjects::DebugMessage::Implementation

strong

Enumerator
DebugKHR |
Legacy |

## Constructor & Destructor Documentation

## DebugMessage()

globjects::DebugMessage::DebugMessage | ( | gl::GLenum | source,
|  | gl::GLenum | type,
|  | gl::GLuint | id,
|  | gl::GLenum | severity,
|  | const std::string & | message
| ) |  |

## Member Function Documentation

## hintImplementation()

static void globjects::DebugMessage::hintImplementation | ( | Implementation | impl | ) |

static

## source()

gl::GLenum globjects::DebugMessage::source | ( |  | ) | const

## type()

gl::GLenum globjects::DebugMessage::type | ( |  | ) | const

## id()

gl::GLuint globjects::DebugMessage::id | ( |  | ) | const

## severity()

gl::GLenum globjects::DebugMessage::severity | ( |  | ) | const

## message()

const std::string & globjects::DebugMessage::message | ( |  | ) | const

## toString()

virtual std::string globjects::DebugMessage::toString | ( |  | ) | const

virtual

## severityString()

std::string globjects::DebugMessage::severityString | ( |  | ) | const

protected

## sourceString()

std::string globjects::DebugMessage::sourceString | ( |  | ) | const

protected

## typeString()

std::string globjects::DebugMessage::typeString | ( |  | ) | const

protected

## enable()

static void globjects::DebugMessage::enable | ( | bool | synchronous = `true` | ) |

static

## disable()

static void globjects::DebugMessage::disable | ( |  | ) |

static

## setCallback()

static void globjects::DebugMessage::setCallback | ( | Callback | callback | ) |

static

## setSynchronous()

static void globjects::DebugMessage::setSynchronous | ( | bool | synchronous | ) |

static

## insertMessage() [1/3]

static void globjects::DebugMessage::insertMessage | ( | gl::GLenum | source,
|  | gl::GLenum | type,
|  | gl::GLuint | id,
|  | gl::GLenum | severity,
|  | gl::GLsizei | length,
|  | const char * | message
| ) |  |

static

## insertMessage() [2/3]

static void globjects::DebugMessage::insertMessage | ( | gl::GLenum | source,
|  | gl::GLenum | type,
|  | gl::GLuint | id,
|  | gl::GLenum | severity,
|  | const std::string & | message
| ) |  |

static

## insertMessage() [3/3]

static void globjects::DebugMessage::insertMessage | ( | const DebugMessage & | message | ) |

static

## enableMessage()

static void globjects::DebugMessage::enableMessage | ( | gl::GLenum | source,
|  | gl::GLenum | type,
|  | gl::GLenum | severity,
|  | gl::GLuint | id
| ) |  |

static

## enableMessages() [1/2]

static void globjects::DebugMessage::enableMessages | ( | gl::GLenum | source,
|  | gl::GLenum | type,
|  | gl::GLenum | severity,
|  | gl::GLsizei | count,
|  | const gl::GLuint * | ids
| ) |  |

static

## enableMessages() [2/2]

static void globjects::DebugMessage::enableMessages | ( | gl::GLenum | source,
|  | gl::GLenum | type,
|  | gl::GLenum | severity,
|  | const std::vector< gl::GLuint > & | ids
| ) |  |

static

## disableMessage()

static void globjects::DebugMessage::disableMessage | ( | gl::GLenum | source,
|  | gl::GLenum | type,
|  | gl::GLenum | severity,
|  | gl::GLuint | id
| ) |  |

static

## disableMessages() [1/2]

static void globjects::DebugMessage::disableMessages | ( | gl::GLenum | source,
|  | gl::GLenum | type,
|  | gl::GLenum | severity,
|  | gl::GLsizei | count,
|  | const gl::GLuint * | ids
| ) |  |

static

## disableMessages() [2/2]

static void globjects::DebugMessage::disableMessages | ( | gl::GLenum | source,
|  | gl::GLenum | type,
|  | gl::GLenum | severity,
|  | const std::vector< gl::GLuint > & | ids
| ) |  |

static

## controlMessages()

static void globjects::DebugMessage::controlMessages | ( | gl::GLenum | source,
|  | gl::GLenum | type,
|  | gl::GLenum | severity,
|  | gl::GLsizei | count,
|  | const gl::GLuint * | ids,
|  | gl::GLboolean | enabled
| ) |  |

static

## isFallbackImplementation()

static bool globjects::DebugMessage::isFallbackImplementation | ( |  | ) |

static

## Member Data Documentation

## m_source

gl::GLenum globjects::DebugMessage::m_source

protected

## m_type

gl::GLenum globjects::DebugMessage::m_type

protected

## m_id

gl::GLuint globjects::DebugMessage::m_id

protected

## m_severity

gl::GLenum globjects::DebugMessage::m_severity

protected

## m_message

std::string globjects::DebugMessage::m_message

protected

The documentation for this class was generated from the following file:

- DebugMessage.h